#X-COM BaseFixer by Spike for X-COM, UFO: Enemy Unknown
#Alpha version - 24 March 2008
#TO DO:
#- Ensure no unintended effects from using as xcuhook4.bat
#- Interactive WRT options
#MAYBE BABY:
#- Read/show/edit Game Save names
#- Bespoke gamepaths outside the 'GAME_[n]'/'MISSDAT' directory convention

version ='Alpha 0.03'
usage = 'python BaseFixer.py [PATH {/path}] GAME {1..8|L:LIVE|SAV:SAVED|A:ALL} [Flags]...'
flags = '[D:DIRT] [P:PHANTOM] [R:RADARX] [Q:QUIET] [SIL:SILENT] [WRT]'
defaultpath = 'U:/'
savedirs = ['/GAME_1','/GAME_2','/GAME_3','/GAME_4','/GAME_5','/GAME_6','/GAME_7','/GAME_8']
livedirs = ['/MISSDAT/']
usageshown = 0
import struct
import sys

def Usage():
    print 'Usage: '
    print usage
    print '    Flags := ',flags
    print '    Default path is: ', defaultpath, '(Do \"SUBST U: .\" in game dir)'

#Program Ident
print "BaseFixer: ", version

#Get command line arguments or set defaults

# Print usage and exit if no command line args at all
if len(sys.argv) == 1 : #first arg is name of .py script
    if not usageshown  :
        Usage()
        usageshown = 1
    sys.exit()

#Get flags
FIXDIRT=sys.argv.count('DIRT') or sys.argv.count('D')
FIXPHANTOM=sys.argv.count('PHANTOM') or sys.argv.count('P')
FIXRADARX=sys.argv.count('RADARX') or sys.argv.count('R')
QUIET=sys.argv.count('QUIET') or sys.argv.count('Q')
SILENT=sys.argv.count('SILENT') or sys.argv.count('SIL')
WRT=sys.argv.count('WRT')

#TO DO - Check for invalid flags/arguments and warn


#Get parameterised arguments

gamepath = defaultpath
if sys.argv.count('PATH') :
    gamepathindex=sys.argv.index('PATH')+1
    gamepath=sys.argv[gamepathindex]
else :
    print 'no PATH specified, defaulting to ', defaultpath
#    if not usageshown  :
#        Usage()
#        usageshown = 1

if sys.argv.count('GAME') :
    GAMEindex=sys.argv.index('GAME')+1
    GAME=sys.argv[GAMEindex]
else :
    print "GAME not specified, exiting."
    if not usageshown  :
        Usage()
        usageshown = 1
    sys.exit()


#Consider numeric and alpha cases of GAME and emit our intended action
if GAME == 'A' or GAME == 'ALL' :
    #Loop over all game files
    if not SILENT:
            print "Will process active game (MISSDAT) and all saved game files GAME_[1..8] under ", gamepath
    gamedirs = livedirs + savedirs
elif GAME == 'SAV' or GAME == 'SAVED' :
    #Loop over all saved game files
    if not SILENT:
            print "Will process all saved game files GAME_[1..8] under ", gamepath
    gamedirs = savedirs
elif GAME == 'L' or GAME == 'LIVE' :
    #Modify current game in MISSDAT
    if not SILENT:
            print "Will process active game (MISSDAT)."
    gamedirs = livedirs
else :
    #Numeric cases - specific GAME_[n]
    try :
        game = int(GAME)
    except ValueError:
        print "Invalid GAME argument, could not convert \'",str(GAME),"\' to a flag or integer."
        if not usageshown  :
            Usage()
            usageshown = 1
        sys.exit()

    if ( game < 1 or game > 8) :
        print 'Invalid GAME \'', str(GAME),'\', must be 1..8' #TO DO: or 'ALL'
        if not usageshown  :
            Usage()
            usageshown = 1
        sys.exit()
    #Checks OK, set gamedir
    if not SILENT:
        print "Will process game",str(game),"."
    gamedirs = ['/GAME_' + str(game)]
    

#MAIN LOOP - repeatedly Load, Process & (if required) Write requested Files

for gamedir in gamedirs :
#Load a file

    filename = gamepath + gamedir + '/base.dat'
    if not SILENT:
        print "***",gamedir, "***"
    if not (SILENT or QUIET):
        print "Opening", filename


    try:
        mybasedat = open (filename, 'rb')
        base = mybasedat.read()
    except IOError, (errno, strerror):
        print "I/O error(%s): %s" % (errno, strerror)
        if not usageshown  :
            Usage()
            usageshown = 1
        sys.exit()
    except:
        print "Unexpected error:", sys.exc_info()[0]
        if not usageshown  :
            Usage()
            usageshown = 1
        raise

    base_backup = base
    if not (SILENT or QUIET):
        print 'Opened Game: '+ gamedir
        print 'File size:', len (base)

    #Process file
    for thisbase in range (0,8):
        offset = thisbase * 292
        thisbasename = str(base[offset+0:offset+16])
        thisbasename = thisbasename[:thisbasename.index('\x00')] #truncate to first null
        detshort=detlong=dethyper=0
        detshortoff=offset+16
        detlongoff=offset+18
        dethyperoff=offset+20
        detshort = struct.unpack ('h', str(base[detshortoff:detshortoff+2]))
        detshort = int(detshort[0])
        detlong = struct.unpack ('h', str(base[detlongoff:detlongoff+2]))
        detlong = int(detlong[0])
        dethyper = struct.unpack ('h', str(base[dethyperoff:dethyperoff+2]))
        dethyper = int(dethyper[0])
        if not (SILENT or QUIET):
            print 'Base ', (thisbase + 1), ' ', thisbasename
        # print 'Detection', 'S', detshort, 'L', detlong, 'H', dethyper
        nsmallradar = nlargeradar = nhyperwave = 0
        # scan facilities
        for slot in range(0,36):
         facaddr = offset+22+(slot)
         factype = base[facaddr]
         completionoff = offset+22+(slot)+36
         completion = base[completionoff]
    #    print 'DEBUG:',slot+1,struct.unpack('cc', str(factype)+str(completion))
         if completion == '\x00':
               # print 'DEBUG: facility completed'
               if factype == '\x04' :
                   nsmallradar = nsmallradar + 1
               elif factype == '\x05' :
                   nlargeradar = nlargeradar + 1
               elif factype == '\x0F' :
                   nhyperwave = nhyperwave + 1
               elif factype == '\xff' :
                   if not SILENT:
                       print ' Paying for Dirt in base', thisbase+1, 'slot',slot+1,'!'
                   if FIXDIRT :
                       #set completion to 0xFF to match factype 0xFF (=dirt)
                       complstr = struct.pack('c','\xff')
                       newbase = base[:completionoff] + complstr + base [completionoff+1:]
                       #print 'DEBUG: newbase len', len (newbase)
                       if len (newbase) == 2336 :
                            base = newbase
                            if not SILENT:
                                print '  dirt fixed, now free.'
                       else:
                           print 'Base size error, exiting.'
                           sys.exit()

               else :
                   pass
        if not (SILENT or QUIET):
            print 'Detection', 'S', detshort, 'L', detlong, 'H', dethyper
            print 'Detectors', 'S', nsmallradar, 'L', nlargeradar, 'H', nhyperwave
        xdetshort = xdetlong = xdethyper = 0
        smallf =  (0.9) ** nsmallradar
        largef =  (0.8) ** nlargeradar
        xdetshort = int (round ((1 - smallf * largef ) * 100))
        xdetlong = int (round ((1 - largef ) * 100))
        if nhyperwave > 0 :
            xdethyper = 100
        else:
            xdethyper = 0
        #special case backward compatible
        if nsmallradar == 1 and nlargeradar == 1 :
            xdetshort = 30
            xdetlong = 20
        if not (SILENT or QUIET):
            print 'X-Detect:', 'S', xdetshort, 'L', xdetlong, 'H', dethyper
        # Firstly, check for phantom radar (computed value less than actual)
        if ((xdetshort < detshort) or (xdetlong < detlong)):
            if not SILENT:
                print ' Phantom Radar in base',thisbase+1,'!'
            #print 'DEBUG', xdetshort, detshort, xdetlong, detlong
            if FIXPHANTOM :
                #set detection values to normal
                detshort = xdetshort
                detshortstr = struct.pack('h',detshort)
                newbase = base[:detshortoff] + detshortstr[0] + base [detshortoff+1:]
                #print 'DEBUG: newbase len', len (newbase)
                if len (newbase) == 2336 :
                    base = newbase
                    if not SILENT:
                        print '  fixed phantom short range detection.'
                else:
                    print 'Base size error, exiting.'
                    sys.exit()

                if detlong != xdetlong :
                    detlong = xdetlong
                    detlongstr = struct.pack('h',detlong)
                    newbase = base[:detlongoff] + detlongstr[0] + base [detlongoff+1:]
                    #print 'DEBUG: newbase len', len (newbase)
                    if len (newbase) == 2336 :
                        base = newbase
                        if not SILENT:
                            print '  fixed phantom long range detection.'
                    else:
                        print 'Base size error, exiting.'
                        sys.exit()

        if (xdethyper < dethyper):
            if not SILENT:
                print ' Phantom Hyper-Wave Decoder in base',thisbase+1,'!'
            #print 'DEBUG', xdethyper, dethyper
            if FIXPHANTOM :
                #set detection values to normal
                #Hyperwave, so standard == Xtra, no difference
                dethyper = xdethyper
                dethyperstr = struct.pack('h',dethyper)
                newbase = base[:dethyperoff] + dethyperstr[0] + base [dethyperoff+1:]
                #print 'DEBUG: newbase len', len (newbase)
                if len (newbase) == 2336 :
                    base = newbase
                    if not SILENT:
                        print '  fixed phantom hyperwave detection.'

        # Increase detection from multiple radars
        if FIXRADARX and (xdetshort <> detshort or xdetlong <> detlong):
              #set detection values using Multiple Radar algorithm
              detshort = xdetshort
              detshortstr = struct.pack('h',detshort)
              newbase = base[:detshortoff] + detshortstr[0] + base [detshortoff+1:]
              #print 'DEBUG: newbase len', len (newbase)
              if len (newbase) == 2336 :
                    base = newbase
                    if not SILENT:
                        print '  improved short range detection to',detshort,'%.'
              detlong = xdetlong
              detlongstr = struct.pack('h',detlong)
              newbase = base[:detlongoff] + detlongstr[0] + base [detlongoff+1:]
              #print 'DEBUG: newbase len', len (newbase)
              if len (newbase) == 2336 :
                    base = newbase
                    if not SILENT:
                        print '  improved long range detection to',detlong,'%.'

    #Finished processing, close file        
    mybasedat.close

    #Check differences if any
    changestofile = 0
    if base == base_backup :
        if not SILENT:
            print "No changes to make to file."
    else:
        if not SILENT:
            print "Changes required to file."
        if not (SILENT or QUIET):
            print 'Updated file size (check):', len (base)
        changestofile = 1

    #TO DO - Offer interactive dialog options



    #Write updates to file, if requested and needed
    backupfilename=filename + '.bak'
    if WRT == changestofile == 1 :
        if not SILENT:
            print "Changes to make and WRT flag set:"
            print "- rewriting file", filename
            print "First saving backup file", backupfilename

        #Make backup
        try :
            bakbasedat = open (backupfilename,'w+b')
            bakbasedat.write(str(base_backup))
            bakbasedat.truncate(2336)
            bakbasedat.close
        except IOError, (errno, strerror):
            print "I/O error(%s): %s" % (errno, strerror)
            print "Unable to save backup file before rewrite, exiting."
            #TO DO: Prompt user with option to continue anyway.
            sys.exit()
        except:
                print "Unexpected error:", sys.exc_info()[0]
                raise

        if not SILENT:
            print "File backed up."

        #Write updated file to disk
        if not SILENT:
            print "Saving file to disk."
        try :
            newbasedat = open (filename,'w+b')
            newbasedat.write(str(base))
            newbasedat.truncate(2336)
            newbasedat.close
        except IOError, (errno, strerror):
            print "I/O error(%s): %s" % (errno, strerror)
            sys.exit()
        except:
            print "Unexpected error:", sys.exc_info()[0]
            raise
        if not SILENT:
            print "Updated file rewritten."
    elif changestofile == 0:
        if not (SILENT or QUIET):
            print "No changes to make, file not rewritten."
    elif changestofile == 1:
        if not SILENT:
            print "Changes to make but WRT flag not set, file not rewritten."

#END OF MAIN LOOP

#END OF MODULE


